/* -ms300m -mx300m */
import java.io.*;
import java.applet.Applet;
import java.awt.FlowLayout;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.Hashtable;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.geometry.*;
import javax.swing.SwingUtilities;
import com.sun.j3d.utils.image.TextureLoader;

public class MeshSmoothing extends Frame implements ActionListener,AdjustmentListener,ItemListener,TextListener{
  Color blanchedalmond  = new Color((float)(1.000000),
				    (float)(0.921569),(float)(0.803922));
  Color teal = new Color((float)(0.000000),(float)(0.501961),
                         (float)(0.501961));
  Transform3D initialcamera;
  Transform3D Rotate90;
  Transform3D initialView;
  Checkbox nringtype,fastCD,ridgenesssaveF;
  PointTool PT = new PointTool();
  int opt=0;
  Checkbox BWcoloring;
  Checkbox nringuni,nringada;
  Checkbox filterRT;
  Checkbox HMC,Levy1,Levy2,IRandom,HFCL21,VSAori,VSAFit,VSAMVS;
  CheckboxGroup vsatype;
  CheckboxGroup initialSeed;
  CheckboxGroup curvaturetype;
  Checkbox svd1,svd2,svd3,svd4,tau;
  Checkbox constrained1,constrained2;
  int pickID=0;
  int pickstate=0;
 
  float Sphereradius = 0.04f;
  CheckboxGroup visctype;
  Checkbox pickball,vismc,viskc,visk1,visk2;
  Checkbox ravion,rigeson,normalon,tangentson1,tangentson2,linesegon;
  int smstate=2;
  boolean checkMB=false;boolean pickMB=false;
  ObjectSphereTransform medialball=null;
  PickObjectTransform indicateMB=null;
  ControlPoint MBcenter=null;ControlPoint pickedCP=null;
  /* Camera Info. */
  Point3d eye = new Point3d(0.0,0.0,0.0);
  Point3d center = new Point3d(0.0,0.0,0.0);
  Vector3d up = new Vector3d(0.0,0.0,0.0);
  
  Vector3d view;
  Point3d picked;
  Point3d mouse;
  //for picking
  Point3d pickpress = new Point3d(0.0,0.0,0.0);
  Point3d pickbase = new Point3d(0.0,0.0,0.0);
  Vector3d currV3d = new Vector3d();
      Point3d cursorP3d = new Point3d(),viewP3d = new Point3d(),initialpickedP = new Point3d();
      Vector4d currV4d = new Vector4d();
      Transform3D 
        currT3d = new Transform3D(),      
        localT3d = new Transform3D(),     
        inverse = new Transform3D(),      
        plate2world = new Transform3D();  
  
  
  Transform3D motion;

  
  SimpleUniverse universe;
  Canvas3D           canvas;
 
  Polyhedron mypolygon=null;
  Texture mtexture=null;
  
  ObjectTransformEMesh myot=null;
       
  MouseRotate rotBehavior;    
  MouseZoom zoomBehavior;
  MouseTranslate transBehavior;
  TransformGroup viewpoint=null;
  
  Button r2dmesh=null;
  
  /* global variable */
  
    int numenettimes = 1;
    /* for application file I/O */
    Menu file;
    Menu save;
    Menu load;
    MenuItem saveview,loadview,loadp,loadsp,savep,savecp,savei;
    
    MenuItem saves;
    MenuItem quit;
    MenuBar mfield;  
    Menu DMeshMeshM,D2MeshMeshM;
    
    Menu ViewO;
    /* Menu Items */
    
    CheckboxMenuItem DMeshnormalcolor,DMeshmeanCPastelcolor,DMeshmeanCPastelcolor2,
      DMeshwireframecolor,DMeshnonecolor,DMeshtrOnOff,DMeshexist;
    CheckboxMenuItem DMeshlighton,DMeshbackfaceon,DMeshmlighton,DMeshvisnormal;
    
    CheckboxMenuItem D2Meshnormalcolor,D2Meshwireframecolor,D2Meshnonecolor,D2MeshtrOnOff,D2Meshexist,D2Meshbackfaceon,D2Meshmlighton;
    
    
    MenuItem CameraInit,CameraTop,CameraBottom,CameraFront,CameraBack,CameraRight,CameraLeft;
    boolean checkApplySmoothing=false;
    Button ApplySmoothing,ApplySubdivision,ApplyDecimation;
    Button InitPosition,setIP;
    TextField Sig1,Sig2,Sig3,STimes;
    TextField SubdivisionTimes,DecimationPercentage;
    
    int subdivisionnumber=1;
    double decimationp=95.0;
    
    Choice OptionBox,ColorBox,SmoothingBox,SubdivisionBox;
    
  int subdivisionstate=3;
  
  // UI Components
  
  
  Panel              controlPanel;
  Panel              canvasPanel;
  Scrollbar          thrSlider;
  Scrollbar th0s,th1s,th2s;
  Scrollbar pickSlider,thtransf;
  
      
  // Scene Graph
  BranchGroup scene;
  
  // Key Frames & Interpolator
  
  LightObject mylight=null;
  
  
  // Flags
  boolean            animationOn = false; 
  GridBagLayout gridbagl;
  
  GridBagConstraints gridbagc;
  public MeshSmoothing() {
   
    gridbagl = new GridBagLayout();
    gridbagc = new GridBagConstraints();
    mfield = makeIOMenuBar();
    this. setLayout(gridbagl);
    this.setMenuBar(mfield); 
    // Create the canvas and the UI
    canvasPanel = new Panel();
    controlPanel = new Panel();
    createCanvasPanel(canvasPanel);
    createControlPanel(controlPanel); 
    
    
    gridbagc.weightx = GridBagConstraints.CENTER;
    //gridbagc.gridwidth = GridBagConstraints.REMAINDER;
    //gridbagc.gridy = GridBagConstraints.RELATIVE;
    
    gridbagl.setConstraints(canvasPanel,gridbagc);
    this.add(canvasPanel);
    
    gridbagc.ipadx = 2;
    gridbagc.gridy = GridBagConstraints.RELATIVE;
   
     gridbagl.setConstraints(controlPanel,gridbagc);
    this.add(controlPanel);
    
    
      

      // Create the scene. 
      scene = createRoot();
      initialcamera = new Transform3D();
      Rotate90  = new Transform3D();
      Rotate90.rotX(-((12.0*Math.PI)/20.0));
      mylight = new LightObject(scene);
      
	
      // Add viewing platform  
      universe = new SimpleUniverse(canvas);
      ViewingPlatform vplt = universe.getViewingPlatform();
      universe.getViewer().getView().setFrontClipDistance(0.0001);
      viewpoint = vplt.getViewPlatformTransform();
      initialView = new Transform3D();
      
      vplt.setNominalViewingTransform();
      viewpoint.getTransform(initialView);
      //View view = universe.getViewer().getView();
      //view.setDepthBufferFreezeTransparent(false);
      universe.addBranchGraph(scene);
      
      
      this.setForeground(teal);
      this.setBackground(blanchedalmond);
      
  }
  
  public BranchGroup createRoot(){
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    objRoot.setCapability(BranchGroup.ALLOW_DETACH);
   
    TransformGroup objTrans = new TransformGroup();
    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
       
    BoundingSphere bounds =
      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
    /*
    MouseRotate behavior = new MouseRotate();
    
    behavior.setTransformGroup(objTrans);
    objTrans.addChild(behavior);
    behavior.setSchedulingBounds(bounds);
    
    MouseZoom behavior2 = new MouseZoom();
    behavior2.setTransformGroup(objTrans);
    objTrans.addChild(behavior2);
    behavior2.setSchedulingBounds(bounds);
    
    MouseTranslate behavior3 = new MouseTranslate();
    behavior3.setTransformGroup(objTrans);
    objTrans.addChild(behavior3);
    behavior3.setSchedulingBounds(bounds);
    */
    // Set up the background
    // Color3f bgColor = new Color3f(0.09f, 0.09f, 0.9f);
    Color3f bgColor    = new Color3f(1.0f, 1.0f, 1.0f);
    
    Background bgNode = new Background(bgColor);
    bgNode.setApplicationBounds(bounds);
    objRoot.addChild(bgNode);
    
    // Set up the ambient light
    Color3f ambientColor = new Color3f(0.2f, 0.2f, 0.2f);
    AmbientLight ambientLightNode = new AmbientLight(ambientColor);
    ambientLightNode.setInfluencingBounds(bounds);
    
    objRoot.addChild(ambientLightNode);
    
    // Set up the directional lights
    Color3f light1Color = new Color3f(0.65f, 0.65f, 0.65f);
    Vector3f light1Direction  = new Vector3f(4.0f, -7.0f, -12.0f);
       
    DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);
    light1.setInfluencingBounds(bounds);
    objRoot.addChild(light1);
    objRoot.compile();
    return objRoot;
  }
  
  public TextField makeTextF(String str,int dn){
    TextField tmp = new TextField(str,dn);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    tmp.addTextListener(this);
    return tmp;
  }
  public Button makeButton(String str){
    Button tmp = new Button(str);
    tmp.setFont(new Font("TimesRoman", Font.BOLD, 12));
    tmp.addActionListener(this);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    return tmp;
  }
  public MenuItem makeMenuItem(String str){
    MenuItem tmp = new MenuItem(str);
    tmp.setFont(new Font("TimesRoman", Font.BOLD, 12));
    tmp.addActionListener(this);
    return tmp;
  }
  
  public Checkbox makeCheckbox(String str,CheckboxGroup cg,boolean judgement){
    Checkbox tmp = new Checkbox(str,cg,judgement);
    tmp.setFont(new Font("TimesRoman", Font.PLAIN, 10));
    tmp.addItemListener(this);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    return tmp;
  }
  
  public Checkbox makeCheckbox(String str,boolean judgement){
    Checkbox tmp = new Checkbox(str,judgement);
    tmp.setFont(new Font("TimesRoman", Font.PLAIN, 12));
    tmp.addItemListener(this);
    tmp.setForeground(teal);
    tmp.setBackground(blanchedalmond);
    return tmp;
  }
  public CheckboxMenuItem makeCheckboxMenuItem(String str,boolean judgement){
    CheckboxMenuItem tmp = new CheckboxMenuItem(str,judgement);
    tmp.setFont(new Font("TimesRoman", Font.BOLD, 10));
    tmp.addItemListener(this);
    return tmp;
  }
    private void createControlPanel(Panel p) {

      p.setLayout(new GridLayout(14,1));
     
      Panel appsmoothing1 = new Panel();
      Panel appsmoothing2 = new Panel();
      Panel appmethod = new Panel();
      Panel appoption = new Panel();
      
      
       setIP = makeButton("set Positions"); 
      InitPosition  = makeButton("Init Positions"); 
      ApplySmoothing= makeButton("Smoothing");
      appsmoothing1.add(ApplySmoothing);
     
      appsmoothing2.add(setIP);
      appsmoothing2.add(InitPosition);
      
      SmoothingBox = new Choice();
      SmoothingBox.add("Non Local Mean");/* smstate=2 */
      SmoothingBox.add("Similarity");/* smstate=0 */
      SmoothingBox.add("Gaussian Noise sigma1");/* smstate=1 */
      SmoothingBox.setFont(new Font("TimesRoman", Font.BOLD, 10));
      SmoothingBox.addItemListener (this);

       
      Label isgLite = new Label("Iteration: ");
      isgLite.setFont(new Font("TimesRoman", Font.BOLD, 12));
      
      STimes= makeTextF("1",3);
     

      appmethod.add(SmoothingBox);
      appmethod.add(isgLite);
      appmethod.add(STimes);
      pickball = makeCheckbox("pick",false);
      OptionBox = new Choice();
      OptionBox.add("Manual");
      
      OptionBox.add("Picked Height");
      OptionBox.add("Average Height");
      OptionBox.setFont(new Font("TimesRoman", Font.BOLD, 10));
      OptionBox.addItemListener (this);
      

      Panel apps1 = new Panel();
      Panel apps2 = new Panel();
      Panel apps3 = new Panel();
      Panel apps12 = new Panel();
      
      
            
      Sig1= makeTextF("0.25",5);
      Sig2= makeTextF("1.0",5);
      Sig3= makeTextF("0.75",5);
      
      
      
      Label isgL2 = new Label("Integral Domain Size (sigma2):");
      isgL2.setFont(new Font("TimesRoman", Font.BOLD, 12));
      Label isgL3 = new Label("Similarity Kernel Size (sigma3):");
      isgL3.setFont(new Font("TimesRoman", Font.BOLD, 12));
      
      Label isgL12 = new Label("Similarity Standard Deviation (sigma1):");
      isgL12.setFont(new Font("TimesRoman", Font.BOLD, 12));
      
      
      
      apps12.add(isgL12);
      apps1.add(pickball);
      apps1.add(OptionBox);
      apps1.add(Sig1);
      
      
      apps2.add(isgL2);
      apps2.add(Sig2);
      
      apps3.add(isgL3);
      apps3.add(Sig3);
      
      
      Panel appcolor = new Panel();
      Label coloringlabel = new Label("Coloring: Flat Shading with ");
      coloringlabel.setFont(new Font("TimesRoman", Font.BOLD, 12));
      ColorBox = new Choice();
      ColorBox.add("Constant");
      ColorBox.add("Similarity");
      ColorBox.add("Mean Curvature");
      ColorBox.add("Method Noise");
      ColorBox.setFont(new Font("TimesRoman", Font.BOLD, 10));
      ColorBox.addItemListener(this);
      appcolor.add(coloringlabel);
      appcolor.add(ColorBox);
      
      
     
      
      
      Label Smoothinglabel = new Label("Smoothing Options");
       Smoothinglabel.setFont(new Font("TimesRoman", Font.ITALIC, 18));
       p.add(Smoothinglabel);
       p.add(appsmoothing1);
       p.add(appsmoothing2);
       
      p.add(appmethod); 
      p.add(apps12);
      
      p.add(apps1);
      p.add(apps2);
      p.add(apps3);
      
      p.add(appcolor);
      
      
      
      
      
       Panel dpaPick = new Panel();
       dpaPick.setLayout(new GridLayout(2,1));
       Label pickslidelabel = new Label("Pick-Sphere Radius");
       pickslidelabel.setFont(new Font("TimesRoman", Font.ITALIC, 10));
       pickSlider = new Scrollbar(Scrollbar.HORIZONTAL, 4,2,0, 16);
       pickSlider.setSize(100,50);
       pickSlider.addAdjustmentListener(this);
       dpaPick.add(pickslidelabel);
       dpaPick.add(pickSlider);
       p.add(dpaPick); /* 9 */
       
       Panel dpaMC = new Panel();
       dpaMC.setLayout(new GridLayout(2,1));
       Label thrlabel = new Label("Threshold for Z-score of color visualizations");
       thrlabel.setFont(new Font("TimesRoman", Font.ITALIC, 10));
       thrSlider = new Scrollbar(Scrollbar.HORIZONTAL, 15,2,1, 31);
       thrSlider.setSize(20,50);
       thrSlider.addAdjustmentListener(this);
       dpaMC.add(thrlabel);
       dpaMC.add(thrSlider);
       p.add(dpaMC); /* 9 */
              
        
	Label appotherlabel = new Label("Mesh Processing Tool");
       appotherlabel.setFont(new Font("TimesRoman", Font.ITALIC, 18));
       Panel app5 = new Panel();
       
       ApplySubdivision = makeButton("Subdivide");
       SubdivisionTimes = makeTextF("1",2);
       app5.add(ApplySubdivision);
       app5.add(SubdivisionTimes);
       
       
       
      
       SubdivisionBox = new Choice();
       SubdivisionBox.add("Loop N");/* subdivisionstate = 3 */
       SubdivisionBox.add("Loop");/* subdivisionstate = 0 */
       SubdivisionBox.add("TC N");/* subdivisionstate = 4 */
       SubdivisionBox.add("TC");/* subdivisionstate = 5 */
       
       SubdivisionBox.add("Butterfly");/* subdivisionstate = 1 */
       SubdivisionBox.add("Linear");/* subdivisionstate = 2 */
       SubdivisionBox.addItemListener (this);
       app5.add(SubdivisionBox);
       p.add(appotherlabel);
       p.add(app5); /* 6 */
      
      
       Panel app7 = new Panel();
       ApplyDecimation = makeButton("GH-Decimation");
       

       app7.add(ApplyDecimation);
       
      
       DecimationPercentage = makeTextF("95.0",5);
       Label percentL = new Label("P: ");
       percentL.setFont(new Font("TimesRoman", Font.BOLD, 12));
       app7.add(percentL);
       app7.add(DecimationPercentage);
       
       
       
       p.add(app7); /* 8 */
       
    }

    /*
     * This creates the Java3D canvas
     */
    private void createCanvasPanel(Panel p) {

        GridBagLayout      gl  = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();

        p.setLayout(gl);
        gbc.gridx = 0;  gbc.gridy = 0;
        gbc.gridwidth = 5;  gbc.gridheight = 5;
        
	
	
	GraphicsConfiguration myconfig = SimpleUniverse.getPreferredConfiguration(); 
        canvas = new Canvas3D(myconfig);
		
	canvas.setDoubleBufferEnable(true);
	canvas.setSize(780,680);
        canvas.setBackground(Color.white);
	p.add(canvas,gbc);
	view = new Vector3d(0.0,0.0,0.0);
	mouse  = new Point3d(0.0,0.0,0.0);
	picked = new Point3d(0.0,0.0,0.0);
		
	motion = new Transform3D();
	canvas.addMouseListener(new MouseAdapter() {
	  
	  public void mouseClicked( MouseEvent e ){
	    /* 
	    if(SwingUtilities.isLeftMouseButton(e) && myot!=null){
	       Node node;
	        if(pickball.getState()){
		 
		 node = pickSurface(e.getX(),e.getY());
		 
		 if(node != null){
		   
		   
		   //universe.getLocale().removeBranchGraph(scene);
		   myot.objTrans.getTransform(motion);
		   motion.invert();
		   motion.transform(picked);
		   
		   
		   
		   //myot.MouseOff();

		   int pickID = mypolygon.getNearlestV(picked);
		   
		   System.out.println("pickID = "+pickID);
		   
		 
		   
		   
		 }
	       }
	     }
	    */

	    if(myot!=null &&  SwingUtilities.isLeftMouseButton(e)){
	       
	       Point3d nearP=null;
	       myot.objTrans.getLocalToVworld(localT3d);
	       
	       inverse.invert(localT3d);
	       //System.out.println("Click");
	       
	       canvas.getImagePlateToVworld(plate2world);
	       canvas.getCenterEyeInImagePlate(viewP3d);
	       plate2world.transform(viewP3d); 
	       canvas.getImagePlateToVworld(plate2world);
	       canvas.getCenterEyeInImagePlate(viewP3d);
	       plate2world.transform(viewP3d); 
	       
	       setPickCoordinatesPress(e.getX(),e.getY());
	       
	       
	       setPickCoordinates(e.getX(),e.getY());
	       
	       
	       pickID = mypolygon.getNearlestV(mouse);
	       //System.out.println(+mouse.x+" "+mouse.y+" "+mouse.z);
	       
	       
	       medialball.setRadius(0,2.0*getDoubleTF(Sig1)*mypolygon.odata.scaler*mypolygon.aveedgel,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
	       
	       
	       
	      
	      
	       
	       indicateMB.setPosition(0,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
	       pickpress.x = MBcenter.point.x=mypolygon.odata.point[pickID].x;
	       pickpress.y = MBcenter.point.y=mypolygon.odata.point[pickID].y;
	       pickpress.z = MBcenter.point.z=mypolygon.odata.point[pickID].z;
	       
	     }


	  }
	  
	  public void mousePressed(MouseEvent e){
	    
	    
	    
	    if(SwingUtilities.isLeftMouseButton(e) && myot!=null){
	      Node node;
	      
	      if(pickball.getState()){
		//System.out.println("Press");
	       
		mypolygon.odata.myobj.setPickable(false);
		//node = pickNodePRIMITIVE(e.getX(),e.getY());
		node = pickNode(e.getX(),e.getY());
		mypolygon.odata.myobj.setPickable(true);
		
		if(node != null){
		  
		  
		  
		  pickedCP = ((PickInfo)(node.getUserData())).pickCP;
		  
		  
		  myot.objTrans.getLocalToVworld(localT3d);
      
		  inverse.invert(localT3d);
      
      
		  canvas.getImagePlateToVworld(plate2world);
		  canvas.getCenterEyeInImagePlate(viewP3d);
		  plate2world.transform(viewP3d); 
		  canvas.getImagePlateToVworld(plate2world);
		  canvas.getCenterEyeInImagePlate(viewP3d);
		  plate2world.transform(viewP3d); 
		  
		  setPickCoordinatesPress(e.getX(),e.getY());
		  pickpress.x = MBcenter.point.x;
		  pickpress.y = MBcenter.point.y;
		  pickpress.z = MBcenter.point.z;
      

		  
		  
		  pickMB=true;
		  
		  myot.MouseOff();
		  
		}
	      }
	    }
	  }
	  
	  public void mouseReleased(MouseEvent e){
	   
	    if(pickMB){
	      if(myot!=null){
	      	myot.MouseOn();
	      }
	      pickMB=false;
	      
	    }
	    
	  }
	  public void mouseEntered(MouseEvent e){}
	  public void mouseExited(MouseEvent e){}
	}
				); 
	
	canvas.addMouseMotionListener(new MouseMotionAdapter() {        
	  public void mouseDragged(MouseEvent e){
	    if(myot!=null && pickMB && SwingUtilities.isLeftMouseButton(e)){
	      //System.out.println("Dragg");
	       
	      Point3d nearP=null;
	      setPickCoordinates(e.getX(),e.getY());
	      
	      
	      pickID = mypolygon.getNearlestV(mouse);
	      
	      
	      medialball.setRadius(pickedCP.ID,2.0*getDoubleTF(Sig1)*mypolygon.odata.scaler*mypolygon.aveedgel,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
	      //medialball.setRadius(pickedCP.ID,2.0*getDoubleTF(Sig1)*mypolygon.odata.scaler*mypolygon.aveedgel,new Point3d(0.0,0.0,0.0),mypolygon.odata.scaler);
	      
	      
	      
		MBcenter.point.x = mypolygon.odata.point[pickID].x;
		MBcenter.point.y = mypolygon.odata.point[pickID].y;
		MBcenter.point.z = mypolygon.odata.point[pickID].z;
		
	      
		indicateMB.setPosition(pickedCP.ID,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
		
		//indicateMB.setPosition(pickedCP.ID,mouse,mypolygon.odata.scaler);
	      
		 
	    }
	  }
	  public void mouseMoved(MouseEvent e){}
	}
				      );
	
	
    }
    
    private Node pickSurface(int mx,int my){
    PickObject pickObject = new PickObject(canvas,scene);
    PickRay pr=(PickRay)pickObject.generatePickRay(mx,my);
    
    SceneGraphPath sgPath = pickObject.pickClosest(mx,my,PickObject.USE_GEOMETRY);
    if(sgPath==null)return null;
    Node node = pickObject.pickNode(sgPath,PickObject.SHAPE3D,1);
    if(node!=null){
      
      double[] dist=new double[1];
       ((Shape3D)node).intersect(sgPath,pr,dist);
      pr.get(picked,view);
      view.scaleAdd(dist[0],picked);
      picked.set(view);
    }
    sgPath = null;
    return node;
  }

  private Node pickNodePRIMITIVE(int mx,int my){
    mypolygon.odata.myobj.setPickable(false);
    
    
    /* If you want to more fast processing, you can move
       mypolygon.myskeleton.myobj.setPickable(false); and
       mypolygon.myskeleton.myobj.setPickable(true); to 
       the pickstate =3 . 
       */
    PickObject pickObject = new PickObject(canvas,scene);
    
    SceneGraphPath sgPath = pickObject.pickClosest(mx,my,PickObject.USE_GEOMETRY);
    
    if(sgPath==null){
      mypolygon.odata.myobj.setPickable(true);
      
      return null;
    }
    Node node = pickObject.pickNode(sgPath,PickObject.PRIMITIVE,1);
    mypolygon.odata.myobj.setPickable(true);
    
    return node;
  }
  
  private void setPickCoordinatesPress(int dx,int dy){
      
    
    canvas.getPixelLocationInImagePlate(dx,dy,pickbase);
    cursorP3d.x = pickbase.x;
    cursorP3d.y = pickbase.y;
    cursorP3d.z = pickbase.z;
    
    canvas.getImagePlateToVworld(motion);
    motion.transform(pickbase);
    myot.objTrans.getTransform(motion);
          
    
    
    //canvas.getPixelLocationInImagePlate(dx,dy,cursorP3d);
    plate2world.transform(cursorP3d);
    
    
    //myot.objTrans.getTransform(currT3d);
    motion.get(currV3d);
    motion.invert();
    
    currV4d.set(currV3d.x,currV3d.y,currV3d.z,1);
    localT3d.transform(currV4d);
    
    currV3d.set(currV4d.x,currV4d.y,currV4d.z);
    currV3d.sub(viewP3d);
    cursorP3d.sub(viewP3d);
    
    double alpha = 
      (currV3d.x * viewP3d.x +
       currV3d.y * viewP3d.y +
       currV3d.z * viewP3d.z) /
      (cursorP3d.x * viewP3d.x +
       cursorP3d.y * viewP3d.y +
       cursorP3d.z * viewP3d.z);
    
    
    Matrix3d m1 = new Matrix3d();
    motion.getRotationScale(m1);
    Transform3D test = new Transform3D(); 
    test.set(m1);
    test.transform(pickbase);
    
    
    pickbase.x *= alpha;
    pickbase.y *= alpha;
    pickbase.z *= alpha;
    
    
    pickbase.x /= mypolygon.odata.scaler;
    pickbase.y /= mypolygon.odata.scaler;
    pickbase.z /= mypolygon.odata.scaler;
    
     
  }  

   



  private void setPickCoordinates(int dx,int dy){
      
    
    canvas.getPixelLocationInImagePlate(dx,dy,mouse);
    cursorP3d.x = mouse.x;
   cursorP3d.y = mouse.y;
   cursorP3d.z = mouse.z;
    
    
    canvas.getImagePlateToVworld(motion);
      
      motion.transform(mouse);
      myot.objTrans.getTransform(motion);
      
      
      //canvas.getPixelLocationInImagePlate(dx,dy,cursorP3d);
      
      plate2world.transform(cursorP3d);
      
      
      //myot.objTrans.getTransform(currT3d);
      //currT3d.get(currV3d);
      motion.get(currV3d);
      motion.invert();
      
      currV4d.set(currV3d.x,currV3d.y,currV3d.z,1);
      localT3d.transform(currV4d);
      
      currV3d.set(currV4d.x,currV4d.y,currV4d.z);
      currV3d.sub(viewP3d);
      cursorP3d.sub(viewP3d);
      
      double alpha = 
	(currV3d.x * viewP3d.x +
	 currV3d.y * viewP3d.y +
	 currV3d.z * viewP3d.z) /
	(cursorP3d.x * viewP3d.x +
	 cursorP3d.y * viewP3d.y +
	 cursorP3d.z * viewP3d.z);
      
      
      Matrix3d m1 = new Matrix3d();
      motion.getRotationScale(m1);
      Transform3D test = new Transform3D(); 
      test.set(m1);
      test.transform(mouse);
      
      
      mouse.x *= alpha;
      mouse.y *= alpha;
      mouse.z *= alpha;
      
      
      mouse.x /= mypolygon.odata.scaler;
      mouse.y /= mypolygon.odata.scaler;
      mouse.z /= mypolygon.odata.scaler;
      currV3d.x = mouse.x-pickbase.x;
      currV3d.y = mouse.y-pickbase.y;
      currV3d.z = mouse.z-pickbase.z;
      if(!(currV3d.x==0.0&&currV3d.y==0.0&&currV3d.z==0.0)){
	mouse.x = pickpress.x + currV3d.x;
	mouse.y = pickpress.y + currV3d.y;
	mouse.z = pickpress.z + currV3d.z;
      }
      
  }
    private Node pickNode(int mx,int my){
	PickObject pickObject = new PickObject(canvas,scene);
	SceneGraphPath sgPath = pickObject.pickClosest(mx,my,PickObject.USE_GEOMETRY);
	if(sgPath==null)return null;
	Node node = pickObject.pickNode(sgPath,PickObject.LINK,1);
    return node;
  }
    
  public int getIntTF(TextField dtf){
    int dummyd=1;
     try{ 
	dummyd = (Integer.valueOf(dtf.getText().trim())).intValue();
       }catch(java.lang.NumberFormatException e){
	 if(dtf.getText()!=null){
	   Toolkit tkForBeep = getToolkit(); 
	   tkForBeep.beep();
	   System.out.println("Erorr ! This is not a number.");
	   System.out.println("Please input again.");
	 }
       }
       return (dummyd);
  } 
  public double getDoubleTF(TextField dtf){
    double dummyd=1.0;
     try{ 
	dummyd = (Double.valueOf(dtf.getText().trim())).doubleValue();
       }catch(java.lang.NumberFormatException e){
	 if(dtf.getText()!=null){
	   Toolkit tkForBeep = getToolkit(); 
	   tkForBeep.beep();
	   System.out.println("Erorr ! This is not a number.");
	   System.out.println("Please input again.");
	 }
       }
       return (dummyd);
  }
   public void textValueChanged(TextEvent e){
     
     int dv2 = getIntTF(SubdivisionTimes);
     double dv3 = getDoubleTF(DecimationPercentage);
     
    if((dv2>0)){
     
      subdivisionnumber = dv2;
    }else{
      Toolkit tkForBeep = getToolkit(); 
      tkForBeep.beep();
      System.out.println("Erorr ! This is not a number.");
      System.out.println("Please input again.");
    }
    if(dv3>=0.0 && dv3 < 100.0){
      
      decimationp = dv3;
    }else{
    Toolkit tkForBeep = getToolkit(); 
      tkForBeep.beep();
      System.out.println("Erorr ! This is not a number.");
      System.out.println("Please input again.");
    
    }
    
   }
     
  
  public void actionPerformed (ActionEvent event) {
    
    Object source = event.getSource();
    System.out.println(source);
    if(source == quit) {
      
      checkquit check = new checkquit(this);
    
         
  
    }else if(source ==CameraInit){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	viewpoint.setTransform(initialView);
      }
    }else if(source ==CameraTop){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y;
	eye.z = center.z+3.0;
	
	up.x = 0.0;
	up.y = 1.0;
	up.z = 0.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
	
      }
    }else if(source ==CameraBottom){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y;
	eye.z = center.z-3.0;
	
	up.x = 0.0;
	up.y = 1.0;
	up.z = 0.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
	
      }
    }else if(source ==CameraFront){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y+3.0;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
	
      }
    }else if(source ==CameraBack){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x;
	eye.y = center.y-3.0;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);	
      }
    }else if(source ==CameraRight){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x+3.0;
	eye.y = center.y;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
      }
    }else if(source ==CameraLeft){
      if(myot!=null){
	myot.objTrans.setTransform(initialcamera);
	Transform3D viewt = new Transform3D();
	eye.x = center.x-3.0;
	eye.y = center.y;
	eye.z = center.z;
	
	up.x = 0.0;
	up.y = 0.0;
	up.z = 1.0;
	viewt.lookAt(eye,center,up);
	viewt.invert();
	viewpoint.setTransform(viewt);
      }
          
    }else if(source ==setIP){
      if(myot!=null&&mypolygon!=null){
	 
	
	   mypolygon.odata.setCInitPosition();
	
      }
    
       
    }else if(source ==InitPosition){
      if(myot!=null&&mypolygon!=null){
	 
	
	   mypolygon.odata.InitPosition();
	   try {
	  if(ColorBox.getSelectedObjects()[0] == "Constant"){
	      mypolygon.odata.myobj.setColor(true);
	      
	    	      
	  }else if(ColorBox.getSelectedObjects()[0] == "Similarity"){
	      if(!checkApplySmoothing){
		  //ColorBox.setSelectedObjects("Constant"); 
	      }else{
		  mypolygon.odata.SimilarityColoring(mypolygon.sim);
	      }
	  }else if(ColorBox.getSelectedObjects()[0] == "Mean Curvature"){
	      
	      


	      mypolygon.odata.MeanCurvatureColoring();
	      
	  }else if(ColorBox.getSelectedObjects()[0] == "Method Noise"){
	      if(!checkApplySmoothing){
		  //ColorBox.setSelectedObjects("Constant"); 
	      }else{
		  
		  mypolygon.odata.DistanceColoring(mypolygon.dist);
		  
	      }
	  }
	} catch (Exception e) {
           System.err.println ("Exception " + e);
        }
      }
    
       
    }else if(source ==ApplySmoothing){
      if(myot!=null&&mypolygon!=null){
	
	mypolygon.ApplySmoothing(smstate,getDoubleTF(Sig1),getDoubleTF(Sig2),getDoubleTF(Sig3),getIntTF(STimes),pickID,opt,ColorBox);
	checkApplySmoothing=true;
      }
    }else if(source ==ApplySubdivision){
      if(myot!=null&&mypolygon!=null){
	
	    mypolygon.OSubdivision(subdivisionstate,subdivisionnumber);
	
      }
    }else if(source ==ApplyDecimation){
      if(myot!=null&&mypolygon!=null){
	
	mypolygon.ODecimation(decimationp);
      }      
      
      
    
    }else  if(source == loadview) {
      if(mypolygon!=null && myot!=null){
      FileDialog loadFileDialog;
	
  String destinationFileName;
	
  loadFileDialog = new FileDialog(this,"Load File",FileDialog.LOAD);
	
  loadFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));

	  loadFileDialog.pack();
	  loadFileDialog.show();
	
  
	  if (loadFileDialog.getFile() != null){
	  
	      destinationFileName = loadFileDialog.getDirectory() + loadFileDialog.getFile();
	     try{
	    
	    FileInputStream output = 
	      new FileInputStream(destinationFileName);
	          
	    ObjectInputStream objout = new ObjectInputStream(output);
	    
	   
	     
	     Transform3D sinitialView = new Transform3D();
	     
	     
	     Matrix4d mymx = ((Matrix4d)(objout.readObject()));
	    sinitialView.set(mymx);
	    myot.objTrans.setTransform(sinitialView);
	    	    
	    
	    objout.close();
	    output.close();
	    
	  }catch (IOException e){
	    System.out.println("IOException");
	  }catch (java.lang.ClassNotFoundException e2){
	     System.out.println("ClassNotFoundExce");
	  } 
	      
	  }
      }
    }else  if(source == saveview){
      if(mypolygon!=null && myot!=null){
	FileDialog saveFileDialog;
	String destinationFileName;
	saveFileDialog = new FileDialog(this,"Save File",FileDialog.SAVE);
	saveFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
	saveFileDialog.pack();
	saveFileDialog.show();  
	if(saveFileDialog.getFile() != null){
	  destinationFileName = saveFileDialog.getDirectory() +
	    saveFileDialog.getFile();
	  try{
	    
	    FileOutputStream output = 
	      new FileOutputStream(destinationFileName);
	    
	    
	    
	    Transform3D sinitialView = new Transform3D();
	    myot.objTrans.getTransform(sinitialView);
	    
	    
	    Matrix4d mymx = new Matrix4d(); 
	    sinitialView.get(mymx);
	    
	    
	    
	    ObjectOutputStream objout = new ObjectOutputStream(output);
	    objout.writeObject(mymx);
	    objout.flush();
	    System.out.println("Finish Save.");	
	    objout.close();
	    
	    //vplt.setNominalViewingTransform();
	    
	    
	    //viewpoint.getTransform(initialView);
	    	    
	    
	    output.close();
	  }catch (InvalidClassException e2){
	    System.out.println("InvalidClassException");
	  }catch(NotSerializableException e3){
	    System.out.println("NotSerializableException");
	  }catch (IOException e){
	    System.out.println("IOException");
	  }

	  }
	  
	}
    }else  if(source ==savei){
      
      FileDialog saveFileDialog;
      String destinationFileName;
      saveFileDialog = new FileDialog(this,"Save File",FileDialog.SAVE);
      saveFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
      saveFileDialog.pack();
      saveFileDialog.show();
      System.out.println("Please wait...");
      
      Image dummyimage;
      
      
      if (saveFileDialog.getFile() != null){
	destinationFileName = saveFileDialog.getDirectory() +
	  saveFileDialog.getFile();
	JPEGCanvas3D myencode = new JPEGCanvas3D(canvas,destinationFileName);
      }
      
      System.out.println("Save finish !");
    }else  if(source == loadp) {
      
      
      if(mypolygon!=null){
		
	 myot.unbind();
	 myot=null;
	 
	 
      }
      DMeshexist.setState(true);
      DMeshbackfaceon.setState(false);
      DMeshmlighton.setState(true);
      
      DMeshtrOnOff.setState(false);     
      DMeshnormalcolor.setState(true);
      DMeshwireframecolor.setState(false);
      DMeshnonecolor.setState(false);
     
     	  pickID=0;
checkApplySmoothing=false;

      


      FileDialog loadFileDialog;
      String destinationFileName;
      loadFileDialog = new FileDialog(this,"Load File",FileDialog.LOAD);
      loadFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
      loadFileDialog.setSize(700,500);
      loadFileDialog.pack(); loadFileDialog.setSize(700,500);
      loadFileDialog.show();
      
      if (loadFileDialog.getFile() != null){
	destinationFileName = loadFileDialog.getDirectory() +
	  loadFileDialog.getFile();
	
	
	mypolygon = new Polyhedron();
	
	if(mypolygon.ReadTPolyData(destinationFileName)){
	  
	  myot = new ObjectTransformEMesh(mypolygon.odata.myobj,scene);
	  
	  myot.changeBackFace(false);
	  
	  if(medialball!=null){
	    medialball.unbind();
	    medialball=null;
	  }
	  if(indicateMB!=null){
	    indicateMB.unbind();
	    indicateMB=null;
	  }
	  indicateMB = new PickObjectTransform(Sphereradius,myot.objTrans,3);
	  pickID=0;
	  MBcenter = new ControlPoint(0,mypolygon.odata.point[pickID].x*mypolygon.odata.scaler,mypolygon.odata.point[pickID].y*mypolygon.odata.scaler,mypolygon.odata.point[pickID].z*mypolygon.odata.scaler,pickID);
	  
	  pickpress.x = MBcenter.point.x;
	  pickpress.y = MBcenter.point.y;
	  pickpress.z = MBcenter.point.z;
	  
	  medialball = new ObjectSphereTransform(1.0f,myot.objTrans,1.0f,0.4f,0.0f);
	  checkMB=false;
	    
	  
	  medialball.unbind();
	  indicateMB.unbind();
	  

	  System.gc();
	  
	}
      }
    }else  if(source == loadsp) {
      
      

      FileDialog loadFileDialog;
      String destinationFileName;
      loadFileDialog = new FileDialog(this,"Load File",FileDialog.LOAD);
      loadFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
      loadFileDialog.setSize(700,500);
      loadFileDialog.pack(); loadFileDialog.setSize(700,500);
      loadFileDialog.show();
      
      if (loadFileDialog.getFile() != null){
	destinationFileName = loadFileDialog.getDirectory() +
	  loadFileDialog.getFile();
	
	
	
	
	mypolygon.ReadTPolyDataSP(destinationFileName);
      }
      
	
   
    }else  if(source == savep){	   
      
      if(mypolygon!=null && myot!=null){
	FileDialog saveFileDialog;
	String destinationFileName;
	saveFileDialog = new FileDialog(this,"Save File",FileDialog.SAVE);
	saveFileDialog.setFont(new Font("TimesRoman", Font.BOLD, 18));
	saveFileDialog.pack();
	saveFileDialog.show();
	int i,j;
	double dummyvalue=0.0;
	if(saveFileDialog.getFile() != null){
	  destinationFileName = saveFileDialog.getDirectory() +
	    saveFileDialog.getFile();
	  try{
	  
	    FileOutputStream output = 
	      new FileOutputStream(destinationFileName);
	    PrintWriter pwp = new PrintWriter(output);
	    pwp.println(mypolygon.odata.numberV);
	    pwp.println(mypolygon.odata.numberF);
		for(i=0;i<mypolygon.odata.numberV;i++){
		  
		    pwp.println(mypolygon.odata.point[i].x+" "+mypolygon.odata.point[i].y+" "+mypolygon.odata.point[i].z);
		  
		}
		j = 3;
		for(i=0;i<mypolygon.odata.numberF;i++){
		    pwp.println(j+" "+mypolygon.odata.Face[i][0]+" "+mypolygon.odata.Face[i][1]+" "+mypolygon.odata.Face[i][2]);
		}
		System.out.println("Finish Save.");	
		pwp.close();
		output.close();
	  }catch (IOException e){
	    System.out.println("IOException");
	  }
	}
      }
      
    
    	
    }
  
  }
  public IDList next(IDList now)
    {
      return (now.next);
    }
  public IDList back(IDList now)
    {
      return (now.back);
    }
  
  public void itemStateChanged (ItemEvent event) {
    Object source = event.getSource();
    ItemSelectable ie = event.getItemSelectable();
    
     if(source == pickball){
      if(mypolygon!=null){
	if(pickball.getState()){
	  if(!checkMB){
	      medialball.setChild(MBcenter,1.0f);
	    medialball.setRadius(0,2.0*getDoubleTF(Sig1)*mypolygon.odata.scaler*mypolygon.aveedgel,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
	    
	    
	    indicateMB.setChild(MBcenter);
	    checkMB=true;
	    
	  }
	  medialball.setRadius(0,2.0*getDoubleTF(Sig1)*mypolygon.odata.scaler*mypolygon.aveedgel,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
	  
	  indicateMB.setPosition(0,mypolygon.odata.point[pickID],mypolygon.odata.scaler);
	  indicateMB.bind();
	  medialball.bind();
	  
	}else{
	  medialball.unbind();indicateMB.unbind();
	}
	
      }else{
	if(pickball.getState())pickball.setState(false);
      }
    }else if(source==SmoothingBox){
	try {
	  if(ie.getSelectedObjects()[0] == "Non Local Mean"){
             smstate=2;
	  }else if(ie.getSelectedObjects()[0] == "Similarity"){
             smstate=0;
	  }else if(ie.getSelectedObjects()[0] == "Gaussian Noise sigma1"){
             smstate=1;
	  }else{
	     smstate=2;
	  }
	} catch (Exception e) {
           System.err.println ("Exception " + e);
        }
       
      }else if(source==ColorBox){
	  if(myot!=null&&mypolygon!=null)
	try {
	  if(ie.getSelectedObjects()[0] == "Constant"){
	      mypolygon.odata.myobj.setColor(true);
	      
	    	      
	  }else if(ie.getSelectedObjects()[0] == "Similarity"){
	      if(!checkApplySmoothing){
		  //ColorBox.setSelectedObjects("Constant"); 
	      }else{
		  mypolygon.odata.SimilarityColoring(mypolygon.sim);
	      }
	  }else if(ie.getSelectedObjects()[0] == "Mean Curvature"){
	      
	      


	      mypolygon.odata.MeanCurvatureColoring();
	      
	  }else if(ie.getSelectedObjects()[0] == "Method Noise"){
	      if(!checkApplySmoothing){
		  //ColorBox.setSelectedObjects("Constant"); 
	      }else{
		  
		  mypolygon.odata.DistanceColoring(mypolygon.dist);
		  
	      }
	  }
	} catch (Exception e) {
           System.err.println ("Exception " + e);
        }
        
      }else if(source==OptionBox){
	try {
	  if(ie.getSelectedObjects()[0] == "Manual"){
             opt=0;
	  }else if(ie.getSelectedObjects()[0] == "Picked Height"){
	    opt=1;
	  }else if(ie.getSelectedObjects()[0] == "Average Height"){
	    opt=2;
	  }else{
	    opt=0;
	  }
	} catch (Exception e) {
           System.err.println ("Exception " + e);
        }
        
      }else if(source==SubdivisionBox){
	  try {
	  if(ie.getSelectedObjects()[0] == "Loop N"){
            subdivisionstate=3;
	    
	  }else if(ie.getSelectedObjects()[0] == "Loop"){
	    subdivisionstate=0;
	  }else if(ie.getSelectedObjects()[0] == "Butterfly"){
	    subdivisionstate=1;
	  }else if(ie.getSelectedObjects()[0] == "Linear"){
	    subdivisionstate=2;
	  
	  }else if(ie.getSelectedObjects()[0] == "TC N"){
	    subdivisionstate=4;
	  
	  }else if(ie.getSelectedObjects()[0] == "TC"){
	    subdivisionstate=5;
	  
	  }else{
	  
	  }
	} catch (Exception e) {
           System.err.println ("Exception " + e);
        }
    
	  
	  
      }else if( source == DMeshwireframecolor||
	       source == DMeshnonecolor||
		source == DMeshnormalcolor||
	       source == DMeshbackfaceon||
	         source == DMeshmlighton ||
	     source == DMeshtrOnOff||
	       source == DMeshexist
	   
       ){
	if(source==DMeshexist){
	if(mypolygon!=null){
	  if(DMeshexist.getState()){
	    
	    //myot.bind();
	    myot.UnsetTransparency();
	  }else{
	    
	    //myot.unbind();
	    myot.SetTransparency(1.0f);
	    
	  }
	}else{
	  DMeshexist.setState(false); 
	}
      }else if(source==DMeshtrOnOff){
	if(myot!=null)
	  if(DMeshtrOnOff.getState()){
	    myot.SetTransparency(0.5f);
	  }else{
	    myot.UnsetTransparency();
	  }
      
	
	
      }else if(source==DMeshbackfaceon){
	if(myot!=null)myot.changeBackFace(DMeshbackfaceon.getState());
	
      }else if(source == DMeshmlighton){
	  
	if(myot!=null)myot.changeMLight(DMeshmlighton.getState());
	

	
      }else{
	if(source== DMeshnormalcolor){
	  if(DMeshnormalcolor.getState()){
	    if(mypolygon!=null){
	      
	      myot.Surface();
	      
	    }
	    DMeshnonecolor.setState(false);
	    DMeshwireframecolor.setState(false);
	    
	  }
	
	
	}else if(source== DMeshnonecolor){
	  if(DMeshnonecolor.getState()){
	    if(mypolygon!=null){
	      myot.Point();
	      
	    }
	    DMeshnormalcolor.setState(false);
	    DMeshwireframecolor.setState(false);
	
	  }
	  
	}else if(source== DMeshwireframecolor){
	  if(DMeshwireframecolor.getState()){
	    if(mypolygon!=null){
	      myot.WireFrame();
	     
	    }
	    DMeshnonecolor.setState(false);
	    DMeshnormalcolor.setState(false);
	
	  }
	}
	
      }
    
    
    
    
    }else if(source == DMeshlighton){
      
      universe.getLocale().removeBranchGraph(scene);
      
      if(!DMeshlighton.getState()){
	mylight.unbind();
	mylight=null;
	
      }else{
	mylight = new LightObject(scene);
      }
      
      universe.addBranchGraph(scene);
    
    
      
    }
  }
  
  


  public void adjustmentValueChanged (AdjustmentEvent e) {
    int value = e.getValue();
    //System.out.println("value = "+value);
    Object source = e.getSource();
    if(source==pickSlider){
      Sphereradius = ((float)(((double)(0.01*((double)(value))))));
      if(myot!=null&&indicateMB!=null){
	
	
	
	
	universe.getLocale().removeBranchGraph(scene);
	indicateMB.changeSR(Sphereradius);
	universe.addBranchGraph(scene);
	
	
      }

    

    }else if(source==thrSlider){
      if(mypolygon!=null){
	
	  mypolygon.odata.threshold = ((((double)(value))/10.0));
	if(ColorBox.getSelectedObjects()[0] == "Mean Curvature"){
	  mypolygon.odata.MeanCurvatureColoring();
	    
	}else if(ColorBox.getSelectedObjects()[0] =="Method Noise"){
	  
	      if(checkApplySmoothing){
		 		  
		  mypolygon.odata.DistanceColoring(mypolygon.dist);
		  
	      }
	
	}else if(ColorBox.getSelectedObjects()[0] =="Similarity"){
	  if(checkApplySmoothing){
	
		  mypolygon.odata.SimilarityColoring(mypolygon.sim);
	      }
	
	}
	
      }
    }
    
  }

  
  public MenuBar makeIOMenuBar(){
    MenuBar returnout;
    returnout = new MenuBar();
    
    /* file Menu */
    quit = new MenuItem("exit program");
    file = new Menu("file");
    file.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    save = new Menu("save");
    load = new Menu("load");
    save.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    load.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    savei = new MenuItem("save image (.jpg)");
    savei.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    savei.addActionListener(this);
    
    quit.addActionListener(this);
    
    loadp = new MenuItem("load (poly2)");
    loadp.setFont(new Font("TimesRoman", Font.PLAIN, 18));
   loadsp = new MenuItem("load (poly2) for point[]");
    loadsp.setFont(new Font("TimesRoman", Font.PLAIN, 18));
   
    
    savep = new MenuItem("save (poly2)");
    savep.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    saveview = new MenuItem("save view");
    saveview.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    loadview = new MenuItem("load view");
    loadview.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    loadp.addActionListener(this);loadsp.addActionListener(this);
    savep.addActionListener(this);
    loadview.addActionListener(this);
    saveview.addActionListener(this);
    load.add(loadp);
    
 
    load.addSeparator();
    load.add(loadview);
    load.addSeparator();
    save.add(savep);
    save.addSeparator();
    
    load.add(loadsp);
     load.addSeparator();

        
    save.add(saveview);
    save.addSeparator();
    save.add(savei);save.addSeparator();
    
    file.add(quit);
    
    file.add(load);
    file.add(save);
    returnout.add(file);
    
    /* Menu for DMesh Mesh */
   
    DMeshMeshM = new Menu("Original Mesh");
    DMeshMeshM.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    MenuItem DMeshlabel = new MenuItem("E-Mesh");
    DMeshlabel.setFont(new Font("TimesRoman", Font.ITALIC, 13));
    DMeshexist = makeCheckboxMenuItem("exist",false);
    MenuItem DMeshrender = new MenuItem("Rendering Option");
    DMeshrender.setFont(new Font("TimesRoman", Font.ITALIC, 13));
    DMeshnormalcolor = makeCheckboxMenuItem("Face",true);
    
    
    DMeshwireframecolor = makeCheckboxMenuItem("WireFrame",false);
    DMeshnonecolor = makeCheckboxMenuItem("Points",false);
    
    DMeshlighton  = makeCheckboxMenuItem("2 Lights",true); 
    DMeshbackfaceon  = makeCheckboxMenuItem("Back Face",false); 
    DMeshmlighton   = makeCheckboxMenuItem("Material Light",true); 
    
    
    DMeshtrOnOff  = makeCheckboxMenuItem("transparency",false); 
    DMeshvisnormal   = makeCheckboxMenuItem("normal vector",false); 
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshlabel);
    DMeshMeshM.add(DMeshexist);
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshrender);
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshnormalcolor);
     DMeshMeshM.add(DMeshwireframecolor);
    DMeshMeshM.add(DMeshnonecolor);
    DMeshMeshM.addSeparator();
    DMeshMeshM.add(DMeshlighton);
    DMeshMeshM.add(DMeshbackfaceon);
    DMeshMeshM.add(DMeshmlighton);
    
    DMeshMeshM.add(DMeshtrOnOff);
    DMeshMeshM.addSeparator();
    returnout.add(DMeshMeshM);
    
       
        


    ViewO = new Menu("Camera");
    ViewO.setFont(new Font("TimesRoman", Font.PLAIN, 18));
    
    
    MenuItem DMeshViewM = new MenuItem("Camera View Options");
    DMeshViewM.setFont(new Font("TimesRoman", Font.ITALIC, 13));
        
    CameraTop = makeMenuItem("Top");
    CameraInit = makeMenuItem("Init");
    CameraBottom = makeMenuItem("Bottom");
    CameraFront = makeMenuItem("Front");
    CameraBack = makeMenuItem("Back");
    CameraRight = makeMenuItem("Right");
    CameraLeft = makeMenuItem("Left");
    ViewO.addSeparator();
    ViewO.add(DMeshViewM);
     ViewO.addSeparator();
     ViewO.addSeparator();
     ViewO.add(CameraInit);
     ViewO.addSeparator();
     ViewO.add(CameraTop);
     ViewO.add(CameraBottom);
     ViewO.add(CameraFront);
     ViewO.add(CameraBack);
     ViewO.add(CameraRight);
     ViewO.add(CameraLeft);
 
     ViewO.addSeparator();
  returnout.add(ViewO);


  return returnout;
    
  }

    public static void main(String[] args) {
     MeshSmoothing cardboard = new MeshSmoothing();
      cardboard.setSize(1150,790);
      cardboard.setTitle("Smoothing by Example: Non-Local Mean Mesh Denoising ToolKit");
      cardboard.setVisible(true);
      System.out.println("Non-Local Mean Mesh Smoothing Java 3D Viewer written by Shin Yoshizawa");
      System.out.println("Copyright: Shin Yoshizawa, 2006");
      System.out.println("shin.yoshizawa@mpi-inf.mpg.de, MPII");
      
    }
  
}
