

import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class PointTool{
    Point3d cen = new Point3d(0.0,0.0,0.0);Point3d base1 = new Point3d(0.0,0.0,0.0);Point3d base2 = new Point3d(0.0,0.0,0.0);Point3d base3 = new Point3d(0.0,0.0,0.0);
  public PointTool(){
  
  
  }
    private int SearchI(int dID,IDList dIHead,IDList dITail){
    
    IDList now = dIHead;
    while(now.next!=dITail){
      now = now.next;
      if((now.ID==dID)){
	return 1;
      }
    }
    return 0;
}
    public double getArea(Point3d v1,Point3d v2,Point3d v3){
	makeVector(base1,v1,v2);
	makeVector(base2,v1,v3);
	CrossVector(base3,base1,base2);
	return 0.5*(Point3dSize(base3));
	
    }
  public void AppendISort(int dID,IDList dIHead,IDList dITail,int nowID,int [] dnum){
  if(dID!=nowID){
    if(SearchI(dID,dIHead,dITail)==0){
      
      IDList now = new IDList(dID);
      IDList dummy = dITail.back;
      while(dID<dummy.ID){
	dummy = dummy.back;
	if(dummy==dIHead)break;
      }dummy = dummy.next;
      IDList dummyback=dummy.back;
      
      now.next = dummy;
      dummy.back = now;
      now.back = dummyback;
      dummyback.next =now;
      dnum[nowID]++;
    }
  }else{
    
  }
  
}  

    
    public void makeVector(Point3d out,Point3d v1,Point3d v2){
	out.x = v2.x-v1.x;
	out.y = v2.y-v1.y;
	out.z = v2.z-v1.z;
	
    }
    public void setMatrixVector(Point3d out,double [][] A,Point3d dv){
	out.x = A[0][0]*dv.x+A[0][1]*dv.y+A[0][2]*dv.z;
	out.y = A[1][0]*dv.x+A[1][1]*dv.y+A[1][2]*dv.z;
	out.z = A[2][0]*dv.x+A[2][1]*dv.y+A[2][2]*dv.z;
	
    }
    public void setMatrixVector(Point3d out,Matrix3d A,Point3d dv){
	out.x = A.m00*dv.x+A.m01*dv.y+A.m02*dv.z;
	out.y = A.m10*dv.x+A.m11*dv.y+A.m12*dv.z;
	out.z = A.m20*dv.x+A.m21*dv.y+A.m22*dv.z;
	
    }
  public void AppendVF(int myID,IDList dVTail)
    {
      IDList now = new IDList(myID);
      
      IDList dummy = dVTail.back;
      now.next = dVTail;
      dVTail.back = now;
      now.back = dummy;
      dummy.next =now;
    } 
  public double Distance2(Point3d v1,Point3d v2){
	double dx = v1.x - v2.x;
	double dy = v1.y - v2.y;
	double dz = v1.z - v2.z;
	return (dx*dx+dy*dy+dz*dz);
    
    }
    public double Distance(Point3d v1,Point3d v2){
	double dx = v1.x - v2.x;
	double dy = v1.y - v2.y;
	double dz = v1.z - v2.z;
	return Math.sqrt(dx*dx+dy*dy+dz*dz);
    
    }
    public void setCenter(Point3d out,Point3d v1,Point3d v2,Point3d v3){
      out.x = (v1.x+v2.x+v3.x)/3.0;
    out.y = (v1.y+v2.y+v3.y)/3.0;
    out.z = (v1.z+v2.z+v3.z)/3.0;
    
    }
    public void setCurveTangent(Point3d out,Point3d v1,Point3d v2,Point3d v3){
	double d1 = Distance(v1,v2);if(d1==0.0){System.out.println("Zero !");d1=1.0;}
	double d2 = Distance(v2,v3);if(d2==0.0){System.out.println("Zero !");d2=1.0;}
	
	out.x = (((v3.x - v2.x)/d2) + ((v2.x - v1.x)/d1) 
		 - ((v3.x - v1.x)/(d1+d2))); 
	out.y = (((v3.y - v2.y)/d2) + ((v2.y - v1.y)/d1) 
		 - ((v3.y - v1.y)/(d1+d2))); 
	out.z = (((v3.z - v2.z)/d2) + ((v2.z - v1.z)/d1) 
		 - ((v3.z - v1.z)/(d1+d2))); 
	this.Normalize3D(out);
    }
    
    public IDList next(IDList now)
    {
      return (now.next);
    }
  public IDList back(IDList now)
    {
      return (now.back);
    }
  
    public void setVitrualTangents(Point3d normal,Point3d outt1,Point3d outt2){
  
	
	if(Math.abs(normal.x)<Math.abs(normal.y)){
	    outt1.x = 0.0;
	    outt1.y = -normal.z;
	    outt1.z = normal.y;
	    
	}else{
	    outt1.x = normal.z;
	    outt1.y = 0.0;
	    outt1.z = -normal.x;
	}
	
	this.Normalize3D(outt1);
	this.CrossVector(outt2,normal,outt1);
	this.Normalize3D(outt2);
    }
    public double Inner(Point3d in1,Point3d in2){
	return (in1.x*in2.x+in1.y*in2.y+in1.z*in2.z);
    }
    public double InnerProduct(Point3d in1,Point3d in2){
	return (in1.x*in2.x+in1.y*in2.y+in1.z*in2.z);
    }
    public void CrossVector(Point3d out,Point3d in1,Point3d in2){
      out.x = ((in1.y)*(in2.z) - (in2.y)*(in1.z));
      out.y = ((in1.z)*(in2.x) - (in2.z)*(in1.x));
      out.z = ((in1.x)*(in2.y) - (in2.x)*(in1.y));
    }
    public void Normalize3D(Point3d inout){
      double dsize = Point3dSize(inout);
      if(dsize==0.0)dsize=1.0;
      inout.x /= dsize;
      inout.y /= dsize;
      inout.z /= dsize;
    }
    public void Normalize3D(Point3d out,Point3d inout){
      double dsize = Point3dSize(inout);
      if(dsize==0.0)dsize=1.0;
      out.x = inout.x/dsize;
      out.y = inout.y/dsize;
      out.z = inout.z/dsize;
    }
    public double Point3dSize(Point3d in){
      return Math.sqrt(((in.x)*(in.x)+(in.y)*(in.y)+(in.z)*(in.z)));
    }



}
